#include "bas_niv.h"

int main (int argc, char* argv[]) {
  int desc,entier,i,j;
  void *buf;
  void* buf2;
  entrep_p entree;
  int* entier_p;
  short short_tab[MAX_FREE_BLOCS+1];
  short* short_p;
  noeud_p node_p;

  if (argc != 2) {
    printf("arg mauvais\n");
    exit(EXIT_FAILURE);
  }
  if ((desc=open(argv[1],O_RDONLY)) == -1) {
    perror("open");
    exit(EXIT_FAILURE);
  }

  buf = malloc(128);

  /* Lecture d'un repertoire */
  printf("position: %d\n",lseek(desc,14*128,SEEK_SET));
  if (read(desc,buf,128) != 128) {
    perror("read");
    exit(EXIT_FAILURE);
  }
  /* 1er methode */
  entree = buf;
  printf("Avec entrep-p (%s,%d)\n",entree->nom,entree->numero);
  if (strlen(entree->nom) == 0)
    printf("--Taille nulle\n");
  entree ++;
  printf("Avec entrep-p (%s,%d)\n",entree->nom,entree->numero);
  if (strlen(entree->nom) == 0)
    printf("--Taille nulle\n");
  entree ++;
  printf("Avec entrep-p (%s,%d)\n",entree->nom,entree->numero);
  if (strlen(entree->nom) == 0)
    printf("--Taille nulle\n");
  /* 2eme methode */
  buf2 = buf;
  printf("Avec buf2 (%s,%d)\n",((entrep_p)buf2)->nom,((entrep_p)buf2)->numero);
  if (strlen(((entrep_p)buf2)->nom) == 0)
    printf("--Taille nulle\n");
  buf2 = buf+sizeof(entrep_s);
  printf("Avec buf2 (%s,%d)\n",((entrep_p)buf2)->nom,((entrep_p)buf2)->numero);
  if (strlen(((entrep_p)buf2)->nom) == 0)
    printf("--Taille nulle\n");
  buf2 += sizeof(entrep_s);
  printf("Avec buf2 (%s,%d)\n",((entrep_p)buf2)->nom,((entrep_p)buf2)->numero);
  if (strlen(((entrep_p)buf2)->nom) == 0)
    printf("--Taille nulle\n");

  /* Lecture du 1er bloc */
  lseek(desc,0,SEEK_SET);
  if (read(desc,buf,128) == -1) {
    perror("read");
    exit(EXIT_FAILURE);
  }
  /* Caract du dd */
  entier_p = buf + (1+MAX_FREE_NODES)*sizeof(short);
  printf("\ntaille bloc = %d\n",*entier_p);
  entier_p ++;
  printf("taille zone description = %d\n",*entier_p);
  entier_p ++;
  printf("taille zone noeud = %d\n",*entier_p);
  /* Table des noeuds libres */
  short_p = (short*) realloc(buf,(MAX_FREE_NODES+1)*sizeof(short));
  printf("Table des noeuds libres |");
  for (i=0 ; i<MAX_FREE_NODES ; i++) {
    printf("%d|",short_p[i]);
  }
  printf("|p=%d\n",short_p[MAX_FREE_NODES]);

  buf = malloc(TAILLE_BLOC);
  /* Lecture la table des blocs libres */
  printf("Table des blocs libres 1 %d\n",lseek(desc,0,SEEK_CUR));
  if (read(desc,short_tab,128) != 128) {
    perror("read");
    exit(EXIT_FAILURE);
  }
  for (i=0 ; i<MAX_FREE_BLOCS ; i++) {
    printf("(%d,%d)",i,short_tab[i]);
  }
  printf("|p=%d\n",short_tab[MAX_FREE_BLOCS]);
  while (short_tab[MAX_FREE_BLOCS-1] != 239) {
    lseek(desc,DEBUTBLOC(short_tab[MAX_FREE_BLOCS-1]),SEEK_SET);
    printf("Table des blocs libres 1 %d\n",lseek(desc,0,SEEK_CUR));
    if (read(desc,short_tab,128) != 128) {
      perror("read");
      exit(EXIT_FAILURE);
    }
    for (i=0 ; i<MAX_FREE_BLOCS ; i++) {
      printf("(%d,%d)",i,short_tab[i]);
    }
    printf("|p=%d\n",short_tab[MAX_FREE_BLOCS]);
  }
  /* Quelques noeuds */
  lseek(desc,2*128,SEEK_SET);
  if (read(desc,buf,128) == -1) {
    perror("read");
    exit(EXIT_FAILURE);
  }
  node_p = buf;
  for (i=0 ; i<4 ; i++) {
    printf("Noeud %d-%d - ",i,node_p);
    printf("etat %d - ",node_p->etat);
    printf("type %d - ",node_p->type);
    printf("taille %d - ",node_p->taille);
    printf("liens %d - ",node_p->liens);
    printf("blocs[0] %d - ",node_p->blocs[0]);
    printf("blocs[1] %d\n",node_p->blocs[1]);
    node_p ++;
  }
  if (read(desc,buf,128) == -1) {
    perror("read");
    exit(EXIT_FAILURE);
  }
  node_p = buf;
  for (i=4 ; i<8 ; i++) {
    printf("Noeud %d-%d - ",i,node_p);
    printf("etat %d - ",node_p->etat);
    printf("type %d - ",node_p->type);
    printf("taille %d - ",node_p->taille);
    printf("liens %d - ",node_p->liens);
    printf("blocs[0] %d - ",node_p->blocs[0]);
    printf("blocs[1] %d\n",node_p->blocs[1]);
    node_p ++;
  }

  free(buf);
}
