#ifndef BAS_NIV
#define BAS_NIV

#include "lib_minifs.h"
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>

int read_node (noeud_p buf, n_noeud_s num_noeud);

int write_node (noeud_p buf, n_noeud_s num_noeud);

int read_bloc (void* buf, n_bloc_s num_bloc);

int write_bloc (void* buf, n_bloc_s num_bloc);

int read_free_nodes_table (short dev);

int write_free_nodes_table (short dev);

int read_free_blocs_table (short dev);

int write_free_blocs_table (short dev);

n_noeud_s find_ref (char* reference);

int find_name_in_node(char* name, n_noeud_p node);

int supp_node (n_noeud_s noeud);

n_noeud_s new_node (short dev);

n_bloc_s new_bloc (short dev);

int supp_bloc (n_bloc_s bloc);

noeud_p new_entry (n_noeud_s num_noeud, entrep_p entree);

noeud_p supp_entry (n_noeud_s num_noeud, entrep_p entree);

n_bloc_s num_of_bloc_i (short bloc_i, n_noeud_s num_noeud);

int change_buf (desc_t desc, short pos_new_bloc);

int add_bloc_in_node (n_noeud_s num_noeud, short num_added_bloc, short old_size);

#endif
