#ifndef HAUT_NIV
#define HAUT_NIV

#include "lib_minifs.h"
#include "bas_niv.h"
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>

pos_t lseek_minifs(desc_t descripteur, pos_t position, int mode);

int rmdir_minifs(char *reference);

int close_minifs(desc_t descripteur);

int read_minifs(desc_t descripteur, void *tampon, int taille);

entrep_p readdir_minifs(desc_t descripteur);

int rewinddir_minifs(desc_t descripteur);

int mkdir_minifs(char *reference);

int write_minifs(desc_t descripteur, void *tampon, int taille);

desc_t open_minifs(char *reference, int mode);

int stat_minifs(char *reference, stat_p buf);

int fstat_minifs(desc_t descripteur, stat_p buf);

int link_minifs(char *src, char *dst);

int unlink_minifs(char *src);

int mount_minifs (char *reference, char *disque_unix);

int unmount_minifs (char *reference);

int cause ( );

#endif
